# Pipelines

## Overview

Streams are the backbone of all processing. Joule Management API provides the ability to register, list, detail and undeploy stream pipelines.&#x20;

For further information on the structure of the content payload refer to this [documentation](/joule/components/pipelines.md).&#x20;

## Example stream content

```json
{
  "stream": {
    "name": "basic_tumbling_window_pipeline",
    "enabled": true,
    "eventTimeType": "EVENT_TIME",
    "sources": [
      "nasdaq_quotes_stream"
    ],
    "processing unit": {
      "pipeline": [
        {
          "time window": {
            "emitting type": "tumblingQuoteAnalytics",
            "aggregate functions": {
              "FIRST": [
                "ask"
              ],
              "LAST": [
                "ask"
              ]
            },
            "policy": {
              "type": "tumblingTime",
              "window size": 1000
            }
          }
        }
      ]
    },
    "emit": {
      "select": "symbol, ask_FIRST, ask_LAST"
    },
    "group by": [
      "symbol"
    ]
  }
}
```

{% openapi src="/files/GlCtcBKC4vfe3SdDJyJ9" path="/joule/management/stream/register" method="post" %}
[swagger-docs.json](https://3062398388-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FUU6FZlV07ZD90OzbzGww%2Fuploads%2FwsbKvpoD11cLGV2xB6Dl%2Fswagger-docs.json?alt=media\&token=7d415513-0de4-40a2-9b02-d35b6d39c86f)
{% endopenapi %}

{% openapi src="/files/GlCtcBKC4vfe3SdDJyJ9" path="/joule/management/stream/list" method="get" %}
[swagger-docs.json](https://3062398388-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FUU6FZlV07ZD90OzbzGww%2Fuploads%2FwsbKvpoD11cLGV2xB6Dl%2Fswagger-docs.json?alt=media\&token=7d415513-0de4-40a2-9b02-d35b6d39c86f)
{% endopenapi %}

{% openapi src="/files/GlCtcBKC4vfe3SdDJyJ9" path="/joule/management/stream/detail" method="get" %}
[swagger-docs.json](https://3062398388-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FUU6FZlV07ZD90OzbzGww%2Fuploads%2FwsbKvpoD11cLGV2xB6Dl%2Fswagger-docs.json?alt=media\&token=7d415513-0de4-40a2-9b02-d35b6d39c86f)
{% endopenapi %}

{% openapi src="/files/GlCtcBKC4vfe3SdDJyJ9" path="/joule/management/stream/unregister" method="delete" %}
[swagger-docs.json](https://3062398388-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FUU6FZlV07ZD90OzbzGww%2Fuploads%2FwsbKvpoD11cLGV2xB6Dl%2Fswagger-docs.json?alt=media\&token=7d415513-0de4-40a2-9b02-d35b6d39c86f)
{% endopenapi %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.fractalworks.io/joule/developer-guides/api-endpoints/mangement-api/pipelines.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
